<?php
/**
 * @version		1.5.4
 * @package		Joomla
 * @subpackage	Membership Pro
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2012 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined('_JEXEC') or die();

/**
 * OS Membership controller
 *
 * @package		Joomla
 * @subpackage	Membership Pro
 * @since 1.5
 */
class OSMembershipController extends JControllerLegacy
{

	/**
	 * Constructor function
	 *
	 * @param array $config
	 */
	function __construct($config = array())
	{
		parent::__construct($config);
	}

	/**
	 * Display information
	 *
	 */
	function display()
	{
		$task = $this->getTask();
		$view = JRequest::getVar('view', '');
		if (!$view)
		{
			JRequest::setVar('view', 'plans');
		}
		parent::display();
		OSMembershipHelper::addSubmenus(JRequest::getVar('view', 'plans'));
		OSMembershipHelper::displayCopyRight();
	}

	/**
	 * Fix error build admin menu issue
	 */
	function fix_error_build_admin_menu()
	{
		$db = JFactory::getDbo();
		$sql = 'DELETE FROM #__menu WHERE link LIKE "%index.php?option=com_osmembership%"';
		$db->setQuery($sql);
		$db->query();
	}

	/**
	 * Upgrade database schema
	 */
	function upgrade()
	{
		require_once JPATH_COMPONENT . '/install.osmembership.php';
		com_install();
	}

	function download_invoice()
	{
		$id = JRequest::getInt('id');
		OSMembershipHelper::downloadInvoice($id);
	}

	function download_file()
	{
		$Itemid = JRequest::getInt('Itemid');
		$filePath = 'media/com_osmembership/upload';
		$fileName = JRequest::getVar('file_name', '');
		if (file_exists(JPATH_ROOT . '/' . $filePath . '/' . $fileName))
		{
			while (@ob_end_clean());
			OSMembershipHelper::processDownload(JPATH_ROOT . '/' . $filePath . '/' . $fileName, $fileName, true);
			exit();
		}
		else
		{
			$mainframe = JFactory::getApplication();
			$mainframe->redirect('index.php?option=com_osmembership&Itemid=' . $Itemid, JText::_('OSM_FILE_NOT_EXIST'));
		}
	}

	function import_subscribers()
	{
		$model = $this->getModel('import');
		$numberSubscribers = $model->store();
		if ($numberSubscribers === false)
		{
			$this->setRedirect('index.php?option=com_osmembership&view=import', JText::_('OSM_ERROR_IMPORT_SUBSCRIBERS'));
		}
		else
		{
			$this->setRedirect('index.php?option=com_osmembership&view=subscribers', 
				JText::sprintf('OSM_NUMNER_SUBSCRIBERS_IMPORTED', $numberSubscribers));
		}
	}
}