/****
 * Payment method class
 * @param id
 * @param name
 * @param title
 * @param creditCard
 * @param cardType
 * @param cardCvv
 * @param cardHolderName
 * @return
 */
function PaymentMethod(name, creditCard, cardType, cardCvv, cardHolderName) {	
	this.name = name ;	
	this.creditCard = creditCard ;
	this.cardType = cardType ;
	this.cardCvv = cardCvv ;
	this.cardHolderName = cardHolderName ;
}
/***
 * Get name of the payment method
 * @return string
 */
PaymentMethod.prototype.getName = function() {
	return this.name ;
}
/***
 * This is creditcard payment method or not	
 * @return int
 */
PaymentMethod.prototype.getCreditCard = function() {
	return this.creditCard ;
}
/****
 * Show creditcard type or not
 * @return string
 */
PaymentMethod.prototype.getCardType = function() {
	return this.cardType ;
}
/***
 * Check to see whether card cvv code is required
 * @return string
 */
PaymentMethod.prototype.getCardCvv = function() {
	return this.cardCvv ;
}
/***
 * Check to see whether this payment method require entering card holder name
 * @return
 */
PaymentMethod.prototype.getCardHolderName = function() {
	return this.cardHolderName ;
}
/***
 * Payment method class, hold all the payment methods
 */
function PaymentMethods() {
	this.length = 0 ;
	this.methods = new Array();
}
/***
 * Add a payment method to array
 * @param paymentMethod
 * @return
 */
 PaymentMethods.prototype.Add = function(paymentMethod) {	
	this.methods[this.length] = paymentMethod ;
	this.length = this.length + 1 ;
}
/***
 * Find a payment method based on it's name
 * @param name
 * @return {@link PaymentMethod}
 */
 PaymentMethods.prototype.Find = function(name) {
	for (var i = 0 ; i < this.length ; i++) {
		if (this.methods[i].name == name) {
			return this.methods[i] ;			
		}
	}
	return null ;
}
/***
 * Process event when someone change a payment method
 */ 
function changePaymentMethod() {			
	var form = document.os_form;			
	var paymentMethod;
	for (var i = 0; i < form.payment_method.length; i++) {
		if (form.payment_method[i].checked == true) {
			paymentMethod = form.payment_method[i].value ;
			break;
		}
	}									
	var trCardNumber = document.getElementById('tr_card_number');
	var trExpDate = document.getElementById('tr_exp_date');
	var trCvvCode = document.getElementById('tr_cvv_code');
	var trCardType = document.getElementById('tr_card_type') ;
	var trCardHolderName = document.getElementById('tr_card_holder_name');
	var trBankList = document.getElementById('tr_bank_list');
	method = methods.Find(paymentMethod);
	if (method.getCreditCard()) {
		trCardNumber.style.display = "";				
		trExpDate.style.display = "";				
		trCvvCode.style.display = "";
		if (method.getCardType()) {
			trCardType.style.display = '';
		} else {
			trCardType.style.display = 'none';
		}
		if (method.getCardHolderName()) {
			trCardHolderName.style.display = '';
		} else {
			trCardHolderName.style.display = 'none';
		}
	} else {
		trCardNumber.style.display = "none";				
		trExpDate.style.display = "none";				
		trCvvCode.style.display = "none";
		trCardType.style.display = 'none';
		trCardHolderName.style.display = "none";		
	}
	
	if (paymentMethod == 'os_ideal') {
		trBankList.style.display = '' ;
	} else {
		if (trBankList) {
			trBankList.style.display = 'none' ;
		}
	}	
	
	var trBankRountingNumber = document.getElementById('tr_bank_rounting_number') ;
	var trBankAccountNumber = document.getElementById('tr_bank_account_number');
	var trBankAccountType = document.getElementById('tr_bank_account_type');
	var trBankName = document.getElementById('tr_bank_name');
	var trBankAccountHolder = document.getElementById('tr_bank_account_holder') ;
	
	if (paymentMethod == 'os_echeck') {
		trBankRountingNumber.style.display = '' ;
		trBankAccountNumber.style.display = '' ;
		trBankAccountType.style.display = '' ;
		trBankName.style.display = '' ;
		trBankAccountHolder.style.display = '' ;
	} else {
		trBankRountingNumber.style.display = 'none' ;
		trBankAccountNumber.style.display = 'none' ;
		trBankAccountType.style.display = 'none' ;
		trBankName.style.display = 'none' ;
		trBankAccountHolder.style.display = 'none' ;
	}
}				 
 
 function updateStateList() {
	var form = document.os_form ;
	//First of all, we need to empty the state dropdown
	var list = form.state ;

	// empty the list
	for (i = 1 ; i < list.options.length ; i++) {
		list.options[i] = null;
	}
	list.length = 1 ;
	var i = 0;
	//Get the country index
	var country = form.country.value ;			
	if (country != '') {
		//Find index of the country
		for (var i = 0 ; i < countryNames.length ; i++) {
			if (countryNames[i] == country) {						
				break ;
			}
		}
		//We will find the states
		var countryId = countryIds[i] ;				
		var stateNames = stateList[countryId]; ;
		if (stateNames) {
			var arrStates = stateNames.split(',');
			i = 1 ;
			var state = '';
			var stateName = '' ;
			for (var j = 0 ; j < arrStates.length ; j++) {
				state = arrStates[j] ;
				stateName = state.split(':');
				opt = new Option();
				opt.value = stateName[0];
				opt.text = stateName[1];
				list.options[i++] = opt;
			}
			list.lenght = i ;
		}								
	}					
} 
 
function reloadCaptcha() {									
	document.getElementById('captcha_image').src = 'index.php?option=com_osmembership&task=show_captcha_image&ran=' + Math.random();			
}	

function validateUsername() {
	(function($) {
		var username = $('#username1').val();
		if (username) {					
			var data = {
				'task'	:	'validate_username',					
				'username': $('#username1').val() 										
			};	
			$('#btn-submit').attr('disabled', 'disabled');
			$('#ajax-loading-animation').show();															
			$.ajax({
				type: 'POST',
				url: siteUrl + 'index.php?option=com_osmembership',
				data: data,
				dataType: 'text',
				success: function(msg, textStatus, xhr) {							
					$('#ajax-loading-animation').hide();					
					if (msg == 1) {							
						$('#validate_username_msg').hide();
						$('#btn-submit').removeAttr('disabled');														
					} else {
						$('#validate_username_msg').show();
						$('#username1').focus();
					}						
				},
				error: function(jqXHR, textStatus, errorThrown) {						
					alert(textStatus);
				}
			});		
					
		} else {
			$('#validate_username_msg').hide();
			$('#btn-submit').attr('disabled', 'disabled');
		}	
	})(jQuery);
}

function validateEmail() {
	(function($) {
		var email = jQuery('#email').val();
		if(email) {
			var emailFilter = /^\w+[\+\.\w-]*@([\w-]+\.)*\w+[\w-]*\.([a-z]{2,4}|\d+)$/i
			var ret = emailFilter.test(email);
			if (!ret) {
				alert("<?php echo JText::_('OSM_INVALID_EMAIL_ENTERED'); ?>") ;
				$('#email').focus();					
				return ;
			}						
			var data = {
				'task'	:	'validate_email',					
				'email': $('#email').val() 										
			};	
			$('#btn-submit').attr('disabled', 'disabled');
			$('#ajax-loading-animation').show();															
			$.ajax({
				type: 'POST',
				url: siteUrl + 'index.php?option=com_osmembership',
				data: data,
				dataType: 'text',
				success: function(msg, textStatus, xhr) {													
					$('#ajax-loading-animation').hide();						
					if (msg == 1) {							
						$('#validate_email_msg').hide();						
						$('#btn-submit').removeAttr('disabled');								
					} else {
						$('#validate_email_msg').show();
						$('#email').focus();
					}						
				},
				error: function(jqXHR, textStatus, errorThrown) {						
					alert(textStatus);
				}
			});						
		} else {
			$('#validate_email_msg').hide();
			$('#btn-submit').attr('disabled', 'disabled');
		}	
	})(jQuery);
}


function validateCoupon() {
	(function($) {				
			var data = {
				'task'	:	'calculate_coupon_discount',
				'plan_id' :  planId,
				'amount'	:	$('#amount') ? $('#amount').val() : 0 ,
				'trial_amount'	:	$('#trial_amount') ? $('#trial_amount').val() : 0 ,
				'regular_amount'	:	$('#regular_amount') ? $('#regular_amount').val() : 0 ,										
				'coupon_code'	:	($("#coupon_code").length > 0) ? $('#coupon_code').val() : ''						
			};	
		$('#btn-submit').attr('disabled', 'disabled');
		$('#ajax-loading-animation').show();															
		$.ajax({
			type: 'POST',
			url: siteUrl + 'index.php?option=com_osmembership',
			data: data,
			dataType: 'json',
			success: function(msg, textStatus, xhr) {
				$('#btn-submit').removeAttr('disabled');
				$('#ajax-loading-animation').hide();
				if ($('#amount')) {
					$('#amount').val(msg.amount);
				}
				if ($('#discount_amount')) {
					$('#discount_amount').val(msg.discount_amount);
				}
				if ($('#tax_amount')) {
					$('#tax_amount').val(msg.tax_amount);
				}							
				if ($('#gross_amount')) {								
					$('#gross_amount').val(msg.gross_amount);
				}

				if ($('#trial_amount')) {
					$('#trial_amount').val(msg.trial_amount);
				}
				if ($('#trial_discount_amount')) {
					$('#trial_discount_amount').val(msg.trial_discount_amount);
				}
				if ($('#trial_tax_amount')) {
					$('#trial_tax_amount').val(msg.trial_tax_amount);
				}							
				if ($('#trial_gross_amount')) {								
					$('#trial_gross_amount').val(msg.trial_gross_amount);
				}

				if ($('#regular_amount')) {
					$('#regular_amount').val(msg.regular_amount);
				}
				if ($('#regular_discount_amount')) {
					$('#regular_discount_amount').val(msg.regular_discount_amount);
				}
				if ($('#regular_tax_amount')) {
					$('#regular_tax_amount').val(msg.regular_tax_amount);
				}							
				if ($('#regular_gross_amount')) {								
					$('#regular_gross_amount').val(msg.regular_gross_amount);
				}				
				if (($('#gross_amount').val() != undefined && msg.gross_amount == 0) || ($('#regular_gross_amount').val() != undefined && msg.regular_gross_amount == 0)) {					
					$('.payment_information').css('display', 'none');								
				} else {								
					$('.payment_information').css('display', '');
					changePaymentMethod();
				}
				if (msg.coupon_valid == 1) {						
					$('#coupon_validate_msg').hide();																																								
				} else {
					$('#coupon_validate_msg').show();
				}						
			},
			error: function(jqXHR, textStatus, errorThrown) {						
				alert(textStatus);
			}
		});		
		
	})(jQuery);
}		
