<?php
/**
 * @version		1.5.4
 * @package		Joomla
 * @subpackage	OS Membership
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die ;

/**
 * OSmembership Component Categories Model
 *
 * @package		Joomla
 * @subpackage	OS Membership
 * @since 1.5
 */
class OSMembershipModelCategories extends OSModelList
{

	function __construct()
	{
		parent::__construct();

	}
		
	function _buildContentWhereArray()
	{
		$user = JFactory::getUser();
		$where = array();
		$where[] = ' a.published = 1 ';
		$where[] = ' a.access IN ('.implode(',', $user->getAuthorisedViewLevels()).')' ;
				
		return $where;
	}
	
	function _buildQuery()
	{
		// Get the WHERE and ORDER BY clauses for the query
		$where = $this->_buildContentWhere();
		$query = 'SELECT a.*, COUNT(b.id) AS total_plans FROM #__osmembership_categories AS a'
			.' LEFT JOIN #__osmembership_plans AS b '
			.' ON (a.id=b.category_id AND b.published=1)'
			.$where
			.' GROUP BY a.id '
			.' ORDER BY a.id '		
		;
		//TODO: Add ordering columns to the categories table
		return $query;
	}	
}