<?php
/**
 * @version		1.5.4
 * @package		Joomla
 * @subpackage	OS Membership
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2012 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

class OSMembershipModelPlan extends OSModel
{

	function __construct($config)
	{
		
		parent::__construct($config);
		
		$this->setId(JRequest::getInt('id'));
	}

	function _loadData()
	{
		$user = JFactory::getUser();
		if (!$user->id)
		{
			return parent::_loadData();
		}
		else
		{
			$db = $this->getDbo();
			$query = $db->getQuery(true);
			$query->select('*')
				->from('#__osmembership_plans')
				->where('id=' . $this->_id);
			$db->setQuery($query);
			$row = $db->loadObject();
			if (!$row->enable_renewal)
			{
				$query->clear();
				$query->select('COUNT(*)')
					->from('#__osmembership_subscribers')
					->where('plan_id=' . $row->id)
					->where('published !=0 ')
					->where('(user_id=' . $user->id . ' OR email="' . $user->email . '")');
				$db->setQuery($query);
				$total = $db->loadResult();
				if ($total)
				{
					$row->disable_subscribe = 1;
				}
			}
			
			$this->_data = $row;
		}
	}
}