<?php
/**
 * @version		1.5.4
 * @package		Joomla
 * @subpackage	OS Membership
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2012 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

class OSMembershipModelPlans extends OSModelList
{

	function __construct($config)
	{
		
		parent::__construct($config);
	}

	/**
	 * 
	 * @see OSModelList::_buildContentWhereArray()
	 */
	function _buildContentWhereArray()
	{
		$user = JFactory::getUser();
		$where = array();
		$categoryId = JRequest::getInt('category_id');
		$where[] = ' a.published = 1 ';
		if ($categoryId)
		{
			$where[] = 'a.category_id=' . $categoryId;
		}
		$where[] = ' a.access IN ('.implode(',', $user->getAuthorisedViewLevels()).')' ;
		
		return $where;
	}

	function getData()
	{
		$user = JFactory::getUser();
		if (!$user->id)
		{
			return parent::getData();
		}
		else
		{
			// Lets load the content if it doesn't already exist
			if (empty($this->_data))
			{
				$query = $this->_buildQuery();
				$rows = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
				for ($i = 0, $n = count($rows); $i < $n; $i++)
				{
					$row = $rows[$i];
					if (!$row->enable_renewal)
					{
						$sql = 'SELECT COUNT(*) FROM #__osmembership_subscribers WHERE (email="' . $user->email . '" OR user_id=' . $user->id . ') AND plan_id=' . $row->id . ' AND published != 0 ';
						$this->_db->setQuery($sql);
						$total = (int) $this->_db->loadResult();
						if ($total)
						{
							$row->disable_subscribe = 1;
						}
					}
				}
				
				$this->_data = $rows;
			}
			
			return $this->_data;
		}
	}
}