<?php
/**
 * @version		1.5.4
 * @package		Joomla
 * @subpackage	OS Membership
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2012 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

/**
 * HTML View class for OS Membership component
 *
 * @static
 * @package		Joomla
 * @subpackage	OS Membership
 * @since 1.0
 */
class OSMembershipViewRegister extends JViewLegacy
{

	function display($tpl = null)
	{				
		$db = JFactory::getDBO();				
		$user = JFactory::getUser();
		$config = OSMembershipHelper::getConfig();
		JFactory::getDocument()->addScript(JURI::base(true) . '/components/com_osmembership/assets/js/paymentmethods.js');				
		$userId = $user->get('id');
		$Itemid = JRequest::getInt('Itemid');
		if (!$Itemid)
			$Itemid = OSMembershipHelper::getItemid();
		$planId = JRequest::getInt('id', 0);
		#Check to see whether this is a valid form or not		
		if (!$planId)
		{			
			JFactory::getApplication()->redirect('index.php', JText::_('OSM_INVALID_MEMBERSHIP_PLAN'));
		}		
		$sql = 'SELECT * FROM #__osmembership_plans WHERE id=' . $planId;
		$db->setQuery($sql);
		$plan = $db->loadObject();		
		if ($plan->published == 0 || !$plan)
		{			
			JFactory::getApplication()->redirect('index.php', JText::_('OSM_CANNOT_ACCESS_UNPUBLISHED_PLAN'));
			return;
		}		
		if (!in_array($plan->access, $user->getAuthorisedViewLevels())){
			JFactory::getApplication()->redirect('index.php', JText::_('OSM_NOT_ALLOWED_PLAN'));
		}					
		$paymentMethod = JRequest::getVar('payment_method', os_payments::getDefautPaymentMethod(), 'post');
		if (!$paymentMethod)
			$paymentMethod = os_payments::getDefautPaymentMethod();		
		$renewOptionId = JRequest::getInt('renew_option_id', 0);
		$upgradeOptionId = JRequest::getInt('upgrade_option_id', 0);
		$fromSubscriptionId = JRequest::getInt('from_subscription_id', 0);
		if ($renewOptionId)
		{
			$action = 'renew';
			$message = $config->subscription_renew_form_msg;
		}
		elseif ($upgradeOptionId)
		{
			$action = 'upgrade';
			$message = $config->subscription_upgrade_form_msg;
		}
		else
		{
			$action = 'subscribe';
			if (strlen(trim(strip_tags($plan->subscription_form_message))))
				$message = $plan->subscription_form_message;
			else
				$message = $config->subscription_form_msg;
		}
		###############Payment Methods parameters###############################	
		//Creditcard payment parameters		
		$x_card_num = JRequest::getVar('x_card_num', '', 'post');
		$expMonth = JRequest::getVar('exp_month', date('m'), 'post');
		$expYear = JRequest::getVar('exp_year', date('Y'), 'post');
		$x_card_code = JRequest::getVar('x_card_code', '', 'post');
		$cardHolderName = JRequest::getVar('card_holder_name', '', 'post');
		$lists['exp_month'] = JHTML::_('select.integerlist', 1, 12, 1, 'exp_month', ' id="exp_month" ', $expMonth, '%02d');
		$currentYear = date('Y');
		$lists['exp_year'] = JHTML::_('select.integerlist', $currentYear, $currentYear + 10, 1, 'exp_year', ' id="exp_year" ', $expYear);
		$options = array();
		$cardTypes = explode(',', $config->enable_cardtypes);
		if (in_array('Visa', $cardTypes))
		{
			$options[] = JHTML::_('select.option', 'Visa', JText::_('OSM_VISA_CARD'));
		}
		if (in_array('MasterCard', $cardTypes))
		{
			$options[] = JHTML::_('select.option', 'MasterCard', JText::_('OSM_MASTER_CARD'));
		}
		
		if (in_array('Discover', $cardTypes))
		{
			$options[] = JHTML::_('select.option', 'Discover', JText::_('OSM_DISCOVER'));
		}
		if (in_array('Amex', $cardTypes))
		{
			$options[] = JHTML::_('select.option', 'Amex', JText::_('OSM_AMEX'));
		}
		$lists['card_type'] = JHTML::_('select.genericlist', $options, 'card_type', ' class="inputbox" ', 'value', 'text');
		//Echeck
		$x_bank_aba_code = JRequest::getVar('x_bank_aba_code', '', 'post');
		$x_bank_acct_num = JRequest::getVar('x_bank_acct_num', '', 'post');
		$x_bank_name = JRequest::getVar('x_bank_name', '', 'post');
		$x_bank_acct_name = JRequest::getVar('x_bank_acct_name', '', 'post');
		$options = array();
		$options[] = JHTML::_('select.option', 'CHECKING', JText::_('OSM_BANK_TYPE_CHECKING'));
		$options[] = JHTML::_('select.option', 'BUSINESSCHECKING', JText::_('OSM_BANK_TYPE_BUSINESSCHECKING'));
		$options[] = JHTML::_('select.option', 'SAVINGS', JText::_('OSM_BANK_TYPE_SAVINGS'));
		$lists['x_bank_acct_type'] = JHTML::_('select.genericlist', $options, 'x_bank_acct_type', ' class="inputbox" ', 'value', 'text', JRequest::getVar('x_bank_acct_type'));		
		//IDEAL Mollie payment plugin support
		$idealEnabled = OSMembershipHelper::idealEnabled();		
		if ($idealEnabled)
		{
			$bankLists = OSMembershipHelper::getBankLists();
			$options = array();
			foreach ($bankLists as $bankId => $bankName)
			{
				$options[] = JHTML::_('select.option', $bankId, $bankName);
			}
			$lists['bank_id'] = JHTML::_('select.genericlist', $options, 'bank_id', ' class="inputbox" ', 'value', 'text', JRequest::getInt('bank_id'));
		}
		//Form Fields
		if (JRequest::getVar('first_name', '', 'post'))
		{
			$loadFromProfile = false;
		}
		else
		{
			$loadFromProfile = true;
		}
		$jcFields = new OSMFields($planId, $loadFromProfile);
		list ($fields, $fieldsOutput) = $jcFields->getFields();
		$validations = $jcFields->renderJSValidation();
		$this->assignRef('validations', $validations);
		$this->assignRef('fields', $fields);
		$this->assignRef('fieldsOutput', $fieldsOutput);										
		$registrationErrorCode = JRequest::getVar('registration_error_code', 0);
		$username = JRequest::getVar('username');
		$password = JRequest::getVar('password');
		if ($plan->recurring_subscription)
		{
			$onlyRecurring = 1;
		}
		else
		{
			$onlyRecurring = 0;
		}
		if ($action == 'renew' || $action == 'upgrade')
		{
			$methods = os_payments::getPaymentMethods(false, $onlyRecurring);
		}
		else
		{
			$methods = os_payments::getPaymentMethods(true, $onlyRecurring);
		}	
		if (count($methods) == 0) {
			JFactory::getApplication()->redirect('index.php', JText::_('OSM_NEED_TO_PUBLISH_PLUGIN'));
		}	
		if ($action == 'renew')
		{
			if ($renewOptionId == OSM_DEFAULT_RENEW_OPTION_ID)
			{
				$sql = 'SELECT b.price FROM #__osmembership_subscribers AS a INNER JOIN #__osmembership_plans AS b ON a.plan_id = b.id WHERE a.id=' . $fromSubscriptionId;
				$db->setQuery($sql);
				$amount = $db->loadResult();
			}
			else
			{
				$sql = 'SELECT price FROM #__osmembership_renewrates WHERE id=' . $renewOptionId;
				$db->setQuery($sql);				
				$amount = $db->loadResult();
			}
			
			if ($renewOptionId == OSM_DEFAULT_RENEW_OPTION_ID)
			{
				$numberDays = $plan->subscription_length;
			}
			else
			{
				$sql = 'SELECT number_days FROM #__osmembership_renewrates WHERE id=' . $renewOptionId;
				$db->setQuery($sql);
				$numberDays = $db->loadResult();
			}
			$message = str_replace('[PLAN_TITLE]', $plan->title, $message);
			$message = str_replace('[AMOUNT]', OSMembershipHelper::formatCurrency($amount, $config), $message);
			$message = str_replace('[NUMBER_DAYS]', $numberDays, $message);
		}
		elseif ($action == 'upgrade')
		{
			$sql = 'SELECT price FROM #__osmembership_upgraderules WHERE id=' . $upgradeOptionId;
			$db->setQuery($sql);			
			$amount = $db->loadResult();			
			$sql = 'SELECT b.title FROM #__osmembership_upgraderules AS a INNER JOIN #__osmembership_plans AS b ON a.from_plan_id=b.id WHERE a.id=' . $upgradeOptionId;
			$db->setQuery($sql);
			$fromPlan = $db->loadResult();
			$message = str_replace('[PLAN_TITLE]', $plan->title, $message);
			$message = str_replace('[AMOUNT]', OSMembershipHelper::formatCurrency($amount, $config), $message);
			$message = str_replace('[FROM_PLAN_TITLE]', $fromPlan, $message);		
		}
		else
		{
			if ($plan->recurring_subscription)
			{
				//We will first need to detect regular duration
				list ($frequency, $length) = OSMembershipHelper::getRecurringSettingOfPlan($plan->subscription_length);
				if ($plan->trial_duration)
				{
					$trialPeriorText = JText::_('OSM_TRIAL_RECURRING_SUBSCRIPTION_PERIOR');					
					$trialPeriorText = str_replace('[TRIAL_DURATION]', $plan->trial_duration, $trialPeriorText);					
					switch ($plan->trial_duration_unit)
					{
						case 'D':
							$trialPeriorText = str_replace('[TRIAL_DURATION_UNIT]', $plan->trial_duration > 1 ? JText::_('OSM_DAYS') : JText::_('OSM_DAY'), $trialPeriorText);
							break;
						case 'W':
							$trialPeriorText = str_replace('[TRIAL_DURATION_UNIT]', $plan->trial_duration > 1 ? JText::_('OSM_WEEKS') : JText::_('OSM_WEEK'), $trialPeriorText);
							break;
						case 'M':
							$trialPeriorText = str_replace('[TRIAL_DURATION_UNIT]', $plan->trial_duration > 1 ? JText::_('OSM_MONTHS') : JText::_('OSM_MONTH'), $trialPeriorText);
							break;
						case 'Y':
							$trialPeriorText = str_replace('[TRIAL_DURATION_UNIT]', $plan->trial_duration > 1 ? JText::_('OSM_YEARS') : JText::_('OSM_YEAR'), $trialPeriorText);
							break;
						default:
							$trialPeriorText = str_replace('[TRIAL_DURATION_UNIT]', $plan->trial_duration > 1 ? JText::_('OSM_DAYS') : JText::_('OSM_DAY'), $trialPeriorText);
							break;
					}
					$this->trialPeriorText = $trialPeriorText;										
				}				
				$regularPeriorText = JText::_('OSM_REGULAR_SUBSCRIPTION_PERIOR');								
				$regularPeriorText = str_replace('[REGULAR_DURATION]', $length, $regularPeriorText);
				switch ($frequency) {
					case 'D':
						$regularPeriorText = str_replace('[REGULAR_DURATION_UNIT]', $length > 1 ? JText::_('OSM_DAYS') : JText::_('OSM_DAY'), $regularPeriorText);
						break;
					case 'W':
						$regularPeriorText = str_replace('[REGULAR_DURATION_UNIT]', $length > 1 ? JText::_('OSM_WEEKS') : JText::_('OSM_WEEK'), $regularPeriorText);
						break;
					case 'M':
						$regularPeriorText = str_replace('[REGULAR_DURATION_UNIT]', $length > 1 ? JText::_('OSM_MONTHS') : JText::_('OSM_MONTH'), $regularPeriorText);
						break;
					case 'Y':
						$regularPeriorText = str_replace('[REGULAR_DURATION_UNIT]', $length > 1 ? JText::_('OSM_YEARS') : JText::_('OSM_YEAR'), $regularPeriorText);
						break;
					default:
						$regularPeriorText = str_replace('[REGULAR_DURATION_UNIT]', $length > 1 ? JText::_('OSM_DAYS') : JText::_('OSM_DAY'), $regularPeriorText);
						break;
				}
				$this->regularPeriorText = $regularPeriorText;						
				$amount = $plan->price;
				$message = str_replace('[PLAN_TITLE]', $plan->title, $message);				
				$message = str_replace('[AMOUNT]', $amountText, $message);
				$this->amountText = $amountText;
			}
			else
			{
				$amount = $plan->price;
				$message = str_replace('[PLAN_TITLE]', $plan->title, $message);
				$message = str_replace('[AMOUNT]', OSMembershipHelper::formatCurrency($amount, $config), $message);
			}
		}
		if ($config->enable_tax && $config->tax_rate > 0) {
			$taxAmount = round($amount* $config->tax_rate / 100, 2);			
		}
		else {
			$taxAmount = 0 ;						
		}
		$discountAmount = 0;
		$captchaInvalid = JRequest::getInt('captcha_invalid', 0);
		//Assign variables to template
		$this->userId = $userId;
		$this->paymentMethod = $paymentMethod;
		$this->amount = $amount;
		$this->taxAmount = $taxAmount;
		$this->discountAmount = $discountAmount;
		$this->lists = $lists;
		$this->Itemid = $Itemid;
		$this->config = $config;
		$this->x_card_num = $x_card_num;
		$this->x_card_code = $x_card_code;
		$this->cardHolderName = $cardHolderName;		
		$this->x_bank_aba_code = $x_bank_aba_code;
		$this->x_bank_acct_num = $x_bank_acct_num;
		$this->x_bank_name = $x_bank_name;
		$this->x_bank_acct_name = $x_bank_acct_name;				
		$this->plan = $plan;
		$this->methods = $methods;
		$this->idealEnabled = $idealEnabled;					
		$this->username = $username;
		$this->password = $password;
		$this->registrationErrorCode = $registrationErrorCode;				
		$this->action = $action;
		$this->fromSubscriptionId = $fromSubscriptionId;
		$this->renewOptionId = $renewOptionId;
		$this->upgradeOptionId = $upgradeOptionId;
		$this->message = $message;		
		$this->captchaInvalid = $captchaInvalid;
				
		parent::display($tpl);
	}	
}